# This file is a template, and might need editing before it works on your project.
# Official image for Hashicorp's Terraform. It uses light image which is Alpine
# based as it is much lighter.
#
# Entrypoint is also needed as image by default set `terraform` binary as an
# entrypoint.
image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

# Default output file for Terraform plan
variables:
  PLAN: plan.tfplan
  JSON_PLAN_FILE: tfplan.json

cache:
  paths:
    - .terraform

before_script:
  - terraform --version
  - terraform init -upgrade

stages:
  - validate
  - plan
  - apply
  - destroy

validate:
  stage: validate
  script:
    - terraform validate

plan:
  stage: plan
  except:
    variables:
      - $DESTROY
  script:
    - terraform plan -out=$PLAN
  artifacts:
    paths:
      - $PLAN

apply:
  stage: apply
  only:
    - main
  except:
    variables:
      - $DESTROY
  script:
    - terraform apply -input=false $PLAN
  dependencies:
    - plan

destroy:
  stage: destroy
  only:
    refs:
      - main
      - schedules
    variables:
      - $DESTROY
  script:
    - terraform destroy -auto-approve
